;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; UrForth level 1: self-hosting 32-bit Forth compiler
;; Copyright (C) 2020 Ketmar Dark // Invisible Vector
;; GPLv3 ONLY
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
[IFNDEF] forth:utf
vocabulary utf
[ENDIF]

also utf definitions
;; based on the idea and code from http://bjoern.hoehrmann.de/utf-8/decoder/dfa/
;; code points from invalid range will never be valid, this is the property of the state machine

;; maps bytes to character classes
create utf8dfa
0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c,  ;; 00-0f
0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c,  ;; 10-1f
0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c,  ;; 20-2f
0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c,  ;; 30-3f
0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c,  ;; 40-4f
0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c,  ;; 50-5f
0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c,  ;; 60-6f
0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c, 0x00 c,  ;; 70-7f
0x01 c, 0x01 c, 0x01 c, 0x01 c, 0x01 c, 0x01 c, 0x01 c, 0x01 c, 0x01 c, 0x01 c, 0x01 c, 0x01 c, 0x01 c, 0x01 c, 0x01 c, 0x01 c,  ;; 80-8f
0x09 c, 0x09 c, 0x09 c, 0x09 c, 0x09 c, 0x09 c, 0x09 c, 0x09 c, 0x09 c, 0x09 c, 0x09 c, 0x09 c, 0x09 c, 0x09 c, 0x09 c, 0x09 c,  ;; 90-9f
0x07 c, 0x07 c, 0x07 c, 0x07 c, 0x07 c, 0x07 c, 0x07 c, 0x07 c, 0x07 c, 0x07 c, 0x07 c, 0x07 c, 0x07 c, 0x07 c, 0x07 c, 0x07 c,  ;; a0-af
0x07 c, 0x07 c, 0x07 c, 0x07 c, 0x07 c, 0x07 c, 0x07 c, 0x07 c, 0x07 c, 0x07 c, 0x07 c, 0x07 c, 0x07 c, 0x07 c, 0x07 c, 0x07 c,  ;; b0-bf
0x08 c, 0x08 c, 0x02 c, 0x02 c, 0x02 c, 0x02 c, 0x02 c, 0x02 c, 0x02 c, 0x02 c, 0x02 c, 0x02 c, 0x02 c, 0x02 c, 0x02 c, 0x02 c,  ;; c0-cf
0x02 c, 0x02 c, 0x02 c, 0x02 c, 0x02 c, 0x02 c, 0x02 c, 0x02 c, 0x02 c, 0x02 c, 0x02 c, 0x02 c, 0x02 c, 0x02 c, 0x02 c, 0x02 c,  ;; d0-df
0x0a c, 0x03 c, 0x03 c, 0x03 c, 0x03 c, 0x03 c, 0x03 c, 0x03 c, 0x03 c, 0x03 c, 0x03 c, 0x03 c, 0x03 c, 0x04 c, 0x03 c, 0x03 c,  ;; e0-ef
0x0b c, 0x06 c, 0x06 c, 0x06 c, 0x05 c, 0x08 c, 0x08 c, 0x08 c, 0x08 c, 0x08 c, 0x08 c, 0x08 c, 0x08 c, 0x08 c, 0x08 c, 0x08 c,  ;; f0-ff
;; maps a combination of a state of the automaton and a character class to a state
0x00 c, 0x0c c, 0x18 c, 0x24 c, 0x3c c, 0x60 c, 0x54 c, 0x0c c, 0x0c c, 0x0c c, 0x30 c, 0x48 c, 0x0c c, 0x0c c, 0x0c c, 0x0c c,  ;; 100-10f
0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x00 c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x00 c,  ;; 110-11f
0x0c c, 0x00 c, 0x0c c, 0x0c c, 0x0c c, 0x18 c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x18 c, 0x0c c, 0x18 c, 0x0c c, 0x0c c,  ;; 120-12f
0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x18 c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x18 c, 0x0c c, 0x0c c,  ;; 130-13f
0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x18 c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x24 c,  ;; 140-14f
0x0c c, 0x24 c, 0x0c c, 0x0c c, 0x0c c, 0x24 c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x24 c, 0x0c c, 0x24 c, 0x0c c, 0x0c c,  ;; 150-15f
0x0c c, 0x24 c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x0c c, 0x0c c,
create;

;; states
0x0000_0000 constant Accept
0x0c00_0000 constant Reject
;; mask constant
0xff00_0000 constant Mask


: decoder-init  ( -- state )  Accept ;
: decoder-reset  ( state -- state )  drop Accept ;

;; is current characted valid?
\ : decoder-invalid?  ( state -- bool-flag )  Mask and Reject = ;

;; is current character complete?
: decoder-complete?  ( state -- bool-flag )  Mask and ( Accept =) 0= ;

;; valid only if decoder is in "complete" state
: decoder-currpoint  ( state -- unich )  dup 0x10FFFF u> if drop 0xfffd endif ;

;; never hits "invalid" state, returns "0xfffd" for invalid utf8 sequences
: decode-byte  ( state byte -- state false // state unich true )
  dup utf8dfa + c@ >r  ( state byte | type )
  over Mask and if
    0x3f and over Mask ~and 6 lshift or swap  ;; (b&0x3f)|((codep&~State.Mask)<<6)
  else  ;; first char (decoder is in "accept" state)
    nip 0xff r@ rshift and 0  ;; (0xff>>type)&b
  endif
  ( state oldstate | type )
  24 rshift ( 0xff and) 256 + r> + utf8dfa + c@ dup 12 = if  ;; reject
    2drop 0 0xfffd true
  else
    24 lshift or dup Mask and dup if over swap endif
  endif
;


previous definitions
